#include<netinet/in.h>
#include<sys/time.h>
#include<sys/socket.h>
#include<arpa/inet.h>
#include<unistd.h>
#include<string.h>
#include<stdlib.h>
#include<stdio.h>
#include<netdb.h>

char puffer[4096];
struct struktur
{
  unsigned long count;
  struct timeval tv;
  char last[1];
};

unsigned long anzahl=10;
int gross=64;

double tv2d(struct timeval* tv)
{
   return (double)(tv->tv_sec)+(double)(tv->tv_usec)/1000000.0;
}

#define GLOBAL 1
#ifdef GLOBAL
  struct sockaddr_in local;
  struct sockaddr_in remote;
  socklen_t ll,rl;
#endif
int main(int argc,char **argv)
{
#ifndef GLOBAL
  struct sockaddr_in local;
  struct sockaddr_in remote;
  socklen_t ll,rl;
#endif
  struct struktur *s;
  struct timeval sendtime;
  struct timeval recvtime;
  unsigned long count;
  int fd;
  int r;
  short port=0;
  double laufzeit;
  int len;
  int multicast=0;
  int i;
  struct ip_mreqn mreq[100]; /* fuer Multicast */
  
  /* Aufbauen der Verbindung */
  fd=socket(PF_INET,SOCK_DGRAM,17); 
  if(fd<0)
  { perror("socket");exit(1); 
  }

  local.sin_family=AF_INET;
  local.sin_addr.s_addr=INADDR_ANY;

  while((r=getopt(argc,argv,"p:m:b:r"))!=-1)
  {
    switch(r)
    {
    case 'p': port=atoi(optarg);
              break;
    case 'm':  
              if((r=inet_aton(optarg,&(mreq[multicast].imr_multiaddr))))
              {
                mreq[multicast].imr_address.s_addr=INADDR_ANY;
                mreq[multicast].imr_ifindex=0;
                multicast++;
              }
              else 
              {
                fprintf(stderr,"%s ist keine IP-Adresse \n",optarg);
                exit(1);
              }
	      break;
    case 'b': 
              if(!inet_aton(optarg,&(local.sin_addr)))
              {
                fprintf(stderr,"%s ist keine IP-Adresse \n",optarg); 
                exit(1);
              }
              break;
    case 'r':
	printf("Set SO_REUSEADDR\n");
        {
	    unsigned int reuse=1;
	    int r=setsockopt(fd,SOL_SOCKET,SO_REUSEADDR,&reuse,sizeof(unsigned int));
	    if(r<0)
            {
		perror("sockopt(SOL_SOCKET,SO_REUSEADDR,1)");
	    }
        }
        break;
    default:
         fprintf(stderr,"Aufruf: empfaenger -p port -m mcastaddr \n");
         exit(1);
    }
  }
  local.sin_port=htons(port);

  r=bind(fd,(struct sockaddr *)&local,sizeof(local));if(r<0) { perror("bind");exit(1);}

  ll=sizeof(local);
  r=getsockname(fd,(struct sockaddr *)&local,&ll);
  if(r<0) { perror("getsockname");exit(1);}
  fprintf(stderr,"Lausche an Port %d ... \n",ntohs(local.sin_port));


  for(i=0;i<multicast;i++)
  {
     fprintf(stderr,"Lausche auf Multicast %s ...\n",inet_ntoa(mreq[i].imr_multiaddr));
     r=setsockopt(fd,IPPROTO_IP, IP_ADD_MEMBERSHIP,&mreq[i],sizeof(mreq));
     if(r<0) perror("setsockopt(IP_ADD_MEMBERSHIP)");
  }

  while(1)
  {
     len=recvfrom(fd,puffer,4096,0,(struct sockaddr *)&remote,&rl);
     if(len<0) { perror("recvfrom"); }
     gettimeofday(&recvtime,NULL);
     s = (struct struktur *)puffer;
     count = ntohl(s->count);
        
     sendtime.tv_sec  = ntohl(s->tv.tv_sec);
     sendtime.tv_usec = ntohl(s->tv.tv_usec);

     laufzeit = tv2d(&recvtime)-tv2d(&sendtime);
     printf("%ld from %s %d bytes %gs\n",count,inet_ntoa(remote.sin_addr),len,laufzeit);
  }
  close(fd);
}
